=== debian/changelog ===
golang-1.6-race-detector-runtime (0.0+svn252922-0ubuntu1) xenial; urgency=medium

  * Install to Go-version specific location.

 -- Michael Hudson-Doyle <michael.hudson@canonical.com>  Tue, 08 Mar 2016 16:10:52 +1300

golang-race-detector-runtime (0.0+svn252922-0ubuntu2) xenial; urgency=medium

  * Install to /usr/share rather than /usr/lib, to make uninstallation work
    properly. (LP: #1554401)

 -- Michael Hudson-Doyle <michael.hudson@canonical.com>  Tue, 08 Mar 2016 21:14:01 +1300

golang-race-detector-runtime (0.0+svn252922-0ubuntu1) xenial; urgency=medium

  * Update to version used by Go 1.6. (LP: 1535511)

 -- Michael Hudson-Doyle <michael.hudson@canonical.com>  Tue, 19 Jan 2016 15:28:48 +1300

golang-race-detector-runtime (0.0+svn229396-0ubuntu1) wily; urgency=medium

  * Initial release. (LP: #1487010)

 -- Michael Hudson-Doyle <michael.hudson@canonical.com>  Thu, 10 Sep 2015 13:00:00 +1200
